<?php
/*
Plugin Name: 404 to Home Page
Plugin URI: http://www.fischercreativemedia.com/plugins/
Description: Redirect all 404s to Home Page.
Version: 1.4
Author: Don Fischer
Author URI: http://www.fischercreativemedia.com/
Author Email: dfischer@fischercreativemedia.com
Text Domain: redirect-404-to-home-page
Domain Path: /lang
License:

  Copyright 2016 (dfischer@fischercreativemedia.com)

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License, version 2, as 
  published by the Free Software Foundation.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
  
*/
//Because this is not on the Repository, we need a way to update it if changed.
require_once( plugin_dir_path( __FILE__ ).'/updates/plugin-update-checker.php' );
new FCMPluginUpdateChecker_1_6 ( 'http://graphiccaffeine.com/wp-admin/admin-ajax.php', __FILE__ );

class fourOfourRedirectsToHome {
	function __construct() {
		add_action( 'template_redirect', array( $this, 'personal_redirect_override' ) );
		add_filter( 'redirect_canonical', array( $this, 'personal_redirect_override' ) );
	} 
	
	function personal_redirect_override( $url = '') {
		if (!(defined('DOING_AJAX') && DOING_AJAX) && !is_admin()){
			if( is_404() ){
				header('RedirectType: 404 to Homepage Redirect.');
				wp_redirect(get_bloginfo('url').'/',301);
				exit;
			}
		}
		return $url;
	}
}

new fourOfourRedirectsToHome();